import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    no: CategoryFramePreparer;
    protected bf(): SeriesView;
    ns: CategorySeriesView;
    private n1;
    readonly n2: ICategorySeriesInteractionManager;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private on;
    i2(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    nj(): CategoryAxisBase;
    n3(): NumericAxisBase;
    protected get_cl(): boolean;
    constructor();
    ac(): void;
    oa: boolean;
    n9: boolean;
    protected n5: boolean;
    protected n4: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected oc(): boolean;
    protected od(): boolean;
    protected o0(a: AssigningCategoryStyleEventArgs): void;
    protected oz(a: AssigningCategoryMarkerStyleEventArgs): void;
    nd(a: number, b: number): any[];
    h3(a: boolean, b: SeriesView): void;
    a8(): SeriesComponentsForView;
    ik(): void;
    of: boolean;
    protected j1(a: Rect, b: Rect): void;
    nu: CategoryTransitionInMode;
    ob: boolean;
    protected j0(a: Rect, b: Rect): void;
    protected i7(a: any, b: string, c: any, d: any): void;
    protected n7(): boolean;
    protected n6(): boolean;
    oi(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    fa(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    fp(a: Point): any;
    e8(a: Point): number;
    eb(a: Point): number;
    private nz;
    private n0;
    protected get_n8(): boolean;
    protected readonly n8: boolean;
    au(a: any, b: Point): HighlightingInfo;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected oh(): List$1<Marker>;
    protected ny(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nx(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nw(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    nl: CategoryFrame;
    nn: CategoryFrame;
    nk: CategoryFrame;
    nm: CategoryFrame;
    protected nr: CategorySeriesRenderManager;
    protected ow(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected ox(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    private og;
    protected dc(): boolean;
    protected nt(): CategoryTransitionInMode;
    nv: CategoryTransitionSourceFramePreparer;
    protected h4(): void;
    jm(a: boolean): void;
    protected bo(): TransitionInSpeedType;
    protected oj(): number;
    om(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    ov(a: CategorySeriesView, b: CategoryFrame): void;
    o1(a: CategoryFrame, b: CategorySeriesView): void;
    oy(a: CategoryFrame, b: CategorySeriesView): void;
    ok(a: SeriesView): number;
    ol(a: SeriesView): number;
    ou(a: SeriesView): void;
    jn(a: Rect, b: RenderSurface): void;
    o2(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract oe(): boolean;
    np(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static ne(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    cp: CategorySeries;
    cs: number;
    cr(a: CategoryFrame): boolean;
    cu(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cn: CategoryBucketCalculator;
    co(): CategoryBucketCalculator;
    cq: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    cc(a: (arg1: Marker) => void): void;
    ct(): void;
}
